////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
uniform highp float iTime;
uniform highp float opacity;
uniform highp vec2 inputSize;

highp float random(highp float seed) {
    highp vec3 scale = vec3(4.56, 2.34, 6.78);
    highp vec3 dotVx = vec3(0.78,1.45,6.98);
    return fract(sin(dot(dotVx + seed, scale)) * 43758.5453 + seed);
}

void main() {
    highp vec2 uv = textureCoordinate;
    highp float cellCount = 200.0;
    highp vec2 cellSize = vec2(cellCount, cellCount * inputSize.y / inputSize.x);
    if (inputSize.x > inputSize.y) {
        cellSize = vec2(cellCount * inputSize.x / inputSize.y, cellCount);
    }
    highp vec2 uv_n = ceil(uv * cellSize);
    highp float seed = random(uv_n.x) * 1234.5 + random(uv_n.y) * 2345.6 + iTime;
    highp vec3 col = vec3(random(seed), random(seed + 1.0) , random(seed + 2.0));
    gl_FragColor = vec4(col, opacity);
}