precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform highp vec2 inputSize;
uniform highp float iTime;

uniform int level;
uniform highp float effectValue;

void main() {
    highp vec2 uv = textureCoordinate;
    highp float time = iTime;
    uv.x -= 40.0 / inputSize.x;

    uv += 1.0;
    uv *= 0.5;
    uv = fract(uv);
    uv = abs((uv-0.5) * 2.0);

    vec4 originalColor = texture2D(inputImageTexture, uv);
    originalColor.a *= 0.3;
    gl_FragColor = originalColor;
}