////// Fragment Shader
precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D rainbowTexture;
uniform sampler2D maskTexture;

float lum(vec3 color) {
    return dot(color, vec3(0.299,0.587,0.114));
}

void main()
{
    vec2 uv = textureCoordinate;

    vec4 originalColor = texture2D(inputImageTexture, uv);
    vec4 rainbowColor = texture2D(rainbowTexture, uv);
    vec4 maskColor = texture2D(maskTexture, uv);

    rainbowColor *= maskColor.r ;

    vec4 resultImage = originalColor + rainbowColor * 0.4;
    gl_FragColor = resultImage;
}