precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform highp vec2 inputSize;
uniform highp float iTime;

uniform int level;
uniform highp float effectValue;

const float tau = radians(360.);

vec3 linearToSrgb(const vec3 x){
    return sqrt((-2.8450663e-1*x+1.2580714)*x-2.4727747e-3);
}

void main() {
    highp vec2 uv = textureCoordinate;
    highp float time = iTime;
    //uv.x *= inputSize.x / inputSize.y;
    uv *= 1.5;
    vec3 rainbow0 = linearToSrgb(
    sin( (uv.x+vec3(0,2,1)/3.)*tau ) * .5 + .5
    );

    vec3 rainbow1 = linearToSrgb(
    sin( (uv.y+vec3(0,2,1)/3.)*tau ) * .5 + .5
    );


    vec3 resultCol = rainbow0 * rainbow1;
    gl_FragColor = vec4(resultCol, 1.0);
}